; Written by Coyan of the Mosaic Guild
;
helptxt =
( The hotkeys are as follows

 This Macro assumes you have your chat window open, and will minimize it when it loops through the pulls, but not when choosing crystals.

 Cntl-F1 - this requests and stores info like Memory level, Pull Delay and Number of pulls

 F1 - each time you hit F1 it will mark a crystal, up to 7 crystals. After 7 crystals have been marked, it will tell you to hit F2 or Cntl-F2.

 F2 - will run the mine as many times as you have defined in the initial information.

 Cntl-F2 - This will run the mine once. So if you want to manually pull it, but don't want to deal with the crystal choices, this is an option.

Cntl-q - pauses and un-pauses the macro.

 Cntl-x - This will exit hotkeys and this application.

 Cntl-h - this is the help dialog
)
MemLevel := 6
PullDelay := 5500
Numopulls := 25
MenuX := 15
MenuY := -5
CONSTVAL := 100/255
CRC := 0
color := ""
Mousecnt := 1
ColorN := 0
Cryscnt := 1
ColorHS := 0
ColorDiff := 13
Compd := 0
Minwin :=0

^F1::
	Gui, Add, Text,, Memory Level(1-6):
	Gui, Add, Text,, Pull Delay(miliseconds):
	Gui, Add, Text,, Number of Pulls:
	Gui, Add, Edit, vMemLevel ym Number Limit1,6 ; The ym option starts a new column of controls.
	Gui, Add, Edit, vPullDelay Number,5500
	Gui, Add, Edit, vNumoPulls Number,1000
	Gui, Add, Button, default, OK  ; The label ButtonOK (if it exists) will be run when the button is pressed.
	Gui, Show,, Tungsten Mining
	return  ; End of auto-execute section. The script is idle until the user does something.

	GuiClose:
	ButtonOK:
	Gui, Submit  ; Save the input from the user to each control's associated variable.
return

F1::
	if Cryscnt <=7
	{
		MouseGetPos, MouseX, MouseY
		MX%CrysCnt% := MouseX
		MY%CrysCnt% := MouseY
		Send Marked %Cryscnt% {Enter}
		Cryscnt += 1
	}
	ELSE
	{
		Send All crystals have been marked, please hit F2 to loop or Cntl-F2 for once. {Enter}
	}
return

^F2::

	Loop 7
	{
		MSX := MX%A_Index%
		MSY := MY%A_Index%

		PixelGetColor, color, %MSX%, %MSY%

		CRC := color

		GoSub, CALCHUECOLOR

		CrysColor%A_Index% := ColorN

		; debugging output
		; SEND %ColorN% {Enter}

		Sleep 100
	}

	GoSub, FINDTHEODD

	MeLRv := MemLevel
	Loop %MemLevel%
	{
		MeLRvP := MeLRv - 1

		IF A_Index < %MemLevel%
		{
			IF MEpt%MeLRvP%
			{
				MEpt%MeLRv% := MEpt%MeLRvP%
			}
			ELSE
			{
				MEpt%MeLRv% := Mousecnt
			}
		}
		ELSE
		{
			MEpt%MeLRv% := Mousecnt
		}

		MeLRv -= 1
	}
	Mousecnt := MEpt%MemLevel%

	MSX := MX%Mousecnt%
	MSY := MY%Mousecnt%

	Sleep 200
	Mousemove %MSX%, %MSY%
	Click %MSX%, %MSY%
	MSX += MenuX
	MSY += MenuY
	Sleep 200
	Click %MSX%, %MSY%

	ColorN := 0
return

F2::
	Loop %Numopulls%
	{
		Send ^{F2}

		Sleep PullDelay
;sleep 10000
	}
return

^x::
	ExitApp
return

^q::
	Send {Enter}
	Pause toggle
return

^h::
	MsgBox, %helptxt%
return

CALCHUECOLOR:  ; This procedure calculates the Hue of the crystal
	Minval := 0
	Maxval := 255

	RGBBlue := hextodec(SubStr(CRC, 1, 4))
	RGBGreen := hextodec(SubStr(CRC, 1, 2) . SubStr(CRC, 5, 2))
	RGBRed := hextodec(SubStr(CRC, 1, 2) . SubStr(CRC, 7, 2))

	IF RGBRed > %RGBGreen%
	{
		Minval := RGBGreen
		Maxval := RGBRed
	}
	Else
	{
		Maxval := RGBGreen
		Minval := RGBRed
	}

	IF RGBBlue < %Minval%
	{
		Minval := RGBBlue
	}
	ELSE
	{
		IF RGBBlue > %Maxval%
		{
			Maxval := RGBBlue
		}
	}
	Tmpval := Maxval - Minval

	IF RGBRed = %Maxval%
	{
		ColorN := (RGBGreen - RGBBlue)/Tmpval
	}
	ELSE
	{
		IF RGBGreen = %Maxval%
		{
			ColorN :=2.0 + ((RGBBlue - RGBRed)/Tmpval)
		}
		ELSE
		{
			ColorN := 4.0 + ((RGBRed - RGBGreen)/Tmpval)
		}
	}
	ColorN *= 60
	IF ColorN <= 0.0
	{
		ColorN += 360.0
	}
RETURN

hextodec(hexvalue)
{
	SetFormat, integer, d
	hexvalue += 0
	;SetFormat, integer, hex
	return hexvalue
}

FINDTHEODD: ; This procedure will find the odd crystal out

	loop 7
	{
		CurrCrys := A_Index
		CurrColor := CrysColor%A_Index%
		Match := 0

		GoSub, FINDMATCH

		; debugging output
		;SEND %A_Index% %MatchCrys%{Enter}

		IF Match != 1
		{
			Mousecnt := A_Index
			Break
		}
	}

	; debugging output
	;SEND %Mousecnt% {Enter}

RETURN

FINDMATCH: ; Find a matching crystal to the currcrys

	loop 7
	{
		if A_Index != %CurrCrys%
		{
			ColorHS := ABS(CurrColor - CrysColor%A_Index%)
			IF ColorHS < %ColorDiff%
			{
				Match := 1
				MatchCrys := A_Index
				Break
			}
		}
	}

RETURN